//+----------------------------------------------------------------------+
//|                                           JQS Terminator Line v1.1.0 |
//|                                       Copyright  2010, JQS aka Joo. |
//|                                     http://www.mql4.com/ru/users/joo |
//+----------------------------------------------------------------------+
//|    () ( . terminare  )   |
//| ,   ()    |
//|  () .                                         |
//|                                                                      |
//|    ()    ,   |
//| -              |
//|   .                             |
//|                                                                      |
//|    ()    ( ) |
//|   ,              |
//|  .                                                 |
//+----------------------------------------------------------------------+
#property copyright "Copyright  2010, JQS aka Joo."
#property link      "http://www.mql4.com/ru/users/joo"
//-----------------------------------------------------

//-------------------  ---------------------------
extern string   MM         = "----------- --------";
extern double   K_Martin   =1.0;  // 
extern double   MinLoss    =1.0;  //.     
extern double   ProfitRatio=1.0;  // TP/SL
extern int      SLdefault  =20;   //  SL
//------------------------------------------------------------------------

//------------------- --------------------------------
double TP;            //         
double TakeProfit;    //    TP  ask/bid
double TPline;        //   TP

double SL;            //  
double StopLoss;      //    SL  ask/bid
double SLline;        //   SL

string UsersOrderType;

double Loss;          //     
double Loss_Prev;     //     
double Lots_New;      //    
//------------------------------------------------------------------------

//========================================================================
int init()
{
  //-------------------------------------
  Loss_Prev=MinLoss;
  //-------------------------------------
  return;
}
//========================================================================

//========================================================================
int start()
{ 
  //-------------------------------------
  if (OrdersTotal()>=1)
  {
    ObjectDelete("SignalLineSL");
    ObjectDelete("SignalLineTP");
  } else
  {
    LineDraw();
    LineSens();
    Criterion();// 
    //-------------------------------------
    OpenOrder();
    //-------------------------------------
  }
  //-------------------------------------
  return;
}
//========================================================================

//========================================================================
int deinit()
{
  //-------------------------------------
  ObjectDelete("SignalLineSL");
  ObjectDelete("SignalLineTP");
  //-------------------------------------
  return;
}
//========================================================================

//========================================================================
void Criterion()
{
  bool Flag=true;
  //-------------------------------------
  while (Flag==true)
  {
    if (LineFind()==true)
    {
      LineSens();
      Inform();
    } else
    {
      Flag=false;
    }
  }
  //-------------------------------------
}
//========================================================================

//========================================================================
void LineDraw()
{
  //-------------------------------------
  double ask;
  double bid;
  double point;
  //-------------------------------------
  string Symb=Symbol();
  ask        =MarketInfo(Symb,MODE_ASK);
  bid        =MarketInfo(Symb,MODE_BID);
  point      =MarketInfo(Symb,MODE_POINT);
  //-------------------------------------
  StopLoss   =SLdefault*point;                             //.     SL  ask/bid
  SLline     =bid-StopLoss;                                //.    
  TakeProfit =NormalizeDouble(StopLoss*ProfitRatio,Digits);//.     TP  ask/bid
  TPline     =ask+TakeProfit;                              //.    
  //-------------------------------------
  //  TP
  ObjectCreate("SignalLineTP", OBJ_HLINE, 0,  0,TPline);
  ObjectSet   ("SignalLineTP", OBJPROP_COLOR, Blue);
  //  SL
  ObjectCreate("SignalLineSL", OBJ_HLINE, 0,  0,SLline);
  ObjectSet   ("SignalLineSL", OBJPROP_COLOR, Red);
  //-------------------------------------
}
//========================================================================

//========================================================================
void LineSens()
{
  //-------------------------------------
  RefreshRates();
  string Symb      = Symbol();
  double stoplevel = MarketInfo(Symb,MODE_STOPLEVEL)*Point;//   
  double CurrentValue;
  //-------------------------------------
  //, Buy  Sell 
  CurrentValue       =NormalizeDouble(ObjectGet("SignalLineSL", OBJPROP_PRICE1),Digits);//    SL 

  //      Ask  Bid ...
  if (CurrentValue<(Ask+Bid)*0.5)
  {//...    ----------
    if (Bid-CurrentValue<stoplevel)
    {
      CurrentValue=Bid-stoplevel;
    }
    //  
    UsersOrderType="Buy";
    ObjectMove("SignalLineSL",0,1, CurrentValue);// SL     SL
    SLline     =CurrentValue;                    //.    
    StopLoss   =Bid-SLline;                      //.     SL  ask/bid
    SL         =StopLoss/Point;                  //  SL  

    //  
    TakeProfit =NormalizeDouble(StopLoss*ProfitRatio,Digits);//.     TP  ask/bid
    TP         =TakeProfit/Point;                            //  TP  
    TPline     =Ask+TakeProfit;                              //.    
    ObjectMove("SignalLineTP",0,1, TPline);                  // TP     TP
    //------------------------------------------
  }
  //----------------------------------------------------------
  else
  {//...    ---------
    if (CurrentValue-Ask<stoplevel)
    {
      CurrentValue=Ask+stoplevel;
    }
    //  
    UsersOrderType="Sell";
    ObjectMove("SignalLineSL",0,1, CurrentValue);// SL     SL
    SLline     =CurrentValue;                    //.    
    StopLoss   =SLline-Ask;                      //.     SL  ask/bid
    SL         =StopLoss/Point;                  //  SL  

    //  
    TakeProfit =NormalizeDouble(StopLoss*ProfitRatio,Digits);//.     TP  ask/bid
    TP         =TakeProfit/Point;                            //  TP  
    TPline     =Bid-TakeProfit;                              //.    
    ObjectMove("SignalLineTP",0,1, TPline);                  // TP     TP
    //------------------------------------------
  }
  //-------------------------------------
  WindowRedraw();
}
//========================================================================

//========================================================================
bool LineFind()
{
  //-------------------------------------
  if (ObjectFind("SignalLineTP")==-1)
  {
    return(false);
  } else
  {
    return(true);
  }
  //-------------------------------------
}
//========================================================================

//========================================================================
void OpenOrder()
{
  //-------------------------------------
  int    
  Ticket,    //  
  MN;        // MagicNumber
  bool Modify=false;
  //-------------------------------------
  Lot();

  if (UsersOrderType=="Buy") //   Buy
  {
    Ticket=OrderSend(Symbol(),0,Lots_New,Ask,2,0.0,0.0,"",MN);
    if (Ticket==-1)
      Print("    ,  - ",GetLastError());
    else
    {
      OrderSelect(Ticket, SELECT_BY_TICKET) ;
      Modify=OrderModify(Ticket,OrderOpenPrice(),SLline,TPline,0,Blue);
      if (Modify==true)
        Print("   SL  TP . !!!    !  - ",GetLastError());
    }
  }
  if (UsersOrderType=="Sell") //   Sell
  {

    Ticket=OrderSend(Symbol(),1,Lots_New,Bid,2,0.0,0.0,"",MN);
    if (Ticket==-1)
      Print("    ,  - ",GetLastError());
    else
    {
      OrderSelect(Ticket, SELECT_BY_TICKET) ;
      Modify=OrderModify(Ticket,OrderOpenPrice(),SLline,TPline,0,Red);
      if (Modify==true)
        Print("   SL  TP . !!!    !  - ",GetLastError());
    }
  }
  //-------------------------------------
  Comment("  "+ UsersOrderType+"  StopLoss=", SLline," TakeProfit=", TPline,"  =",Lots_New);
  //-------------------------------------
  return;
}
//========================================================================

//========================================================================
void Lot()
{
  //-------------------------------------
  string Symb    =Symbol();                            //  .
  double One_Lot =MarketInfo(Symb,MODE_MARGINREQUIRED);//  ,    1 
  double Min_Lot =MarketInfo(Symb,MODE_MINLOT);        //. . 
  double Step    =MarketInfo(Symb,MODE_LOTSTEP);       //   
  double Free    =AccountFreeMargin();                 // 
  double LotPrice=MarketInfo(Symb, MODE_TICKVALUE);    // 1      1 
  //-------------------------------------
  if (OrdersHistoryTotal()<1)
  {
    Loss_Prev=MinLoss;
    Lots_New=NormalizeDouble(Loss_Prev/(LotPrice*SL),2);
  } else
  {
    OrderSelect(OrdersHistoryTotal()-1,SELECT_BY_POS, MODE_HISTORY);
    if (OrderProfit()<0)
    {
      Loss_Prev*=K_Martin;
      Lots_New=NormalizeDouble(Loss_Prev/(LotPrice*SL),2);
    } else
    {
      Loss_Prev=MinLoss;
      Lots_New=NormalizeDouble(Loss_Prev/(LotPrice*SL),2);
    }
  }
  //-------------------------------------
}
//========================================================================

//========================================================================
double LotInfo()
{
  //-------------------------------------
  string Symb    =Symbol();                            //  .
  double One_Lot =MarketInfo(Symb,MODE_MARGINREQUIRED);//  ,    1 
  double Min_Lot =MarketInfo(Symb,MODE_MINLOT);        //. . 
  double Step    =MarketInfo(Symb,MODE_LOTSTEP);       //   
  double Free    =AccountFreeMargin();                 // 
  double LotPrice=MarketInfo(Symb, MODE_TICKVALUE);    // 1      1 

  double LossPrevTemp;
  double LotsNewTemp;
  //-------------------------------------
  if (OrdersHistoryTotal()<1)
  {
    LossPrevTemp=MinLoss;
    LotsNewTemp=NormalizeDouble(LossPrevTemp/(LotPrice*SL),2);
  } else
  {
    OrderSelect(OrdersHistoryTotal()-1,SELECT_BY_POS, MODE_HISTORY);
    if (OrderProfit()<0)
    {
      LossPrevTemp=Loss_Prev*K_Martin;
      LotsNewTemp=NormalizeDouble(LossPrevTemp/(LotPrice*SL),2);
    } else
    {
      LossPrevTemp=MinLoss;
      LotsNewTemp=NormalizeDouble(LossPrevTemp/(LotPrice*SL),2);
    }
  }
  //-------------------------------------
  return(LotsNewTemp);
}
//========================================================================

//========================================================================
void Inform()
{
  //-------------------------------------
  string Symb              = Symbol();
  string DepoCurrency      = AccountCurrency();                         //   
  double MeansOneLot       = MarketInfo(Symb,MODE_MARGINREQUIRED);      //    1 
  double MeansFree         = AccountFreeMargin();                       //  ,    
  double MeansGuaranty     = AccountMargin();                           //  ,     
  double LotPriceTic       = MarketInfo(Symb, MODE_TICKVALUE);          // 1      1 
  double MaxLotPermissible = MathFloor((MeansFree/MeansOneLot)*100)/100;//     
  double MaxSLPermissible;                                              //  SL  StopOut

  double stopout;
  string ind;
  //-------------------------------------
  if (AccountStopoutMode()==0)
  {
    stopout=AccountStopoutLevel();
    ind    ="%";
    MaxSLPermissible  = MathFloor((MeansFree*(100-stopout))/(LotPriceTic*LotInfo()*100));
  } else
  {
    stopout=AccountStopoutLevel();
    ind    =DepoCurrency;
    //MaxSLPermissible  = MathFloor( (MeansFree-stopout)/(LotPriceTic*LotInfo()) );
  }
  //-------------------------------------   
  Comment(
         "SLline = ",SLline
         ,"\n",
         "TPline = ",TPline
         ,"\n",
         "TP     = ",TP
         ,"\n",
         "SL     = ",SL//,"  MaxSL=",MaxSLPermissible
         ,"\n",
         "Lot    =",LotInfo(),"  MaxLot=",MaxLotPermissible
         ,"\n",
         "Profit =",LotPriceTic*LotInfo()*TP,"  Loss=",LotPriceTic*LotInfo()*SL
         ,"\n",
         "  = ",MarketInfo(Symb,MODE_STOPLEVEL)
         ,"\n",
         " = ",MarketInfo(Symb,MODE_SPREAD)
         );
}
//========================================================================